/* ks2x.c
 *
 *  Add \begin{sshr} in the beginning and \end{sshr} at the end for 
 *  ks2sshr.  Do not add these delimiters for 'readks'.
 *		   Yoon DaeGyun 1/19/92 - dkyoon
 *
 *  conditional compiling for ORIGINAL, SSHR, and READKS
 *  (See Makefile) jeong seong.gueon, 1/9/92
 *
 *  slightly modified from Choyh's ks2n
 *  modified portions are ifdef'ed by ~ORIGINAL and IBMRS
 *      jeong seong.gueon, 12/17/91
 *
 *  originally Choyh's ks2n.c dated 05/18/90
 */

/**************************************************************


        CODE CONVERTER  

                input  :  KSC 5601 code 
                output :  N byte Standard code for FAST 15.

        Programmed by Choyh in KAIST, Korea.  05/18/90 
                Email :  choyh@csdsun.kaist.ac.kr   

***************************************************************/



#include <stdio.h>
#include "hantbl.h"

#define  ENG    0
#define  KOR    1

char Cho_tbl[21] =
        { 0,0,65,66,68,71,72,73,81,82,83,85,86,87,88,89,90,
          91,92,93,94};
char Jung_tbl[30] =
        { 0,0,98,99,0,100,101,102,0,103,106,107,0,108,108,
          108,0,108,114,115,0,115,115,115,0,119,122,122,0,124};
char Jung_ant[30] = 
        { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,99,0,124,
          0,0,0,102,103,124,0,0,0,124,0,0 }; 
char Jong_tbl[29] =
        { 0,0,65,66,65,68,68,68,71,73,73,73,73,73,73,73,73,81,
          82,82,85,86,87,88,90,91,92,93,94};
char Jong_ant[30] = 
        { 0,0, 0, 0,85, 0,88,94, 0, 0,65,81,82,85,92,93,94,
           0, 0,85, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int  C_Mode=ENG;

#ifdef ORIGINAL
main()
{ int i,j; 
  unsigned char  c1,c2;
  char               c;

        while(1) 
           { c=getchar();
             if(c == EOF)  exit(0);
             c1 = (unsigned)c;
             if(c1&0x80) 
              {  if(C_Mode == ENG) putchar(14);
                 C_Mode = KOR;
                 i=0; i= i^c1; i= i<<8; c2=getchar(); i= i^c2; 
                 intoNbyte(intoCom(i));
              } 
              else 
              {  if(C_Mode == KOR) putchar(15);
                 C_Mode = ENG;
                 putchar(c1);
              }
           }
}
#else /* either SSHR (by default) or READKS */

char pp_ch=' ', p_ch = ' ';  /* previouly seen chars */
int doCapital = 1; /* use XyyZaa rather than xyy.zaa in output */
int wasInKOR = 0;  /* C_Mode was once in KOR */

#define isalpha(x) ((x)>='A'&&(x)<='z')
#define ishangul(x) ((x)&0x80)
#define saveNonAlpha(x) nonAlphaBuf[nsaved]=(x);nsaved++
#define xputchar(x) if((x)=='}'||(x)=='{')putchar((x));putchar((x))
#define flushNonAlpha() {int i=0;char c; for(;i<nsaved;i++){c=nonAlphaBuf[i];xputchar(c);}nsaved=0;}
#define doHangul(x) {int i;unsigned char c2;i=0; i= i^(x); i= i<<8; c2=getchar(); i= i^c2; intoNbyte(intoCom(i));}  
#define poparg argc--; argv++

showUsage(s)
char *s;
{
  fprintf(stderr, "Usage: %s [-h(elp)] [-d(otted)] [filename]\n", s);
}

newStdin(fn)
char *fn;
{
  int fd;
  if ((fd = open(fn, 0)) < 0) {
    fprintf(stderr, "Cannot open: %s.\n", fn);
    exit(1);
  }
  if (dup2(fd, 0) != 0) {
    fprintf(stderr, "Cannot dup2.\n");
    exit(1);
  }
  close(fd);
}
 
main(argc, argv)
int argc;
char **argv;
{ int i,j; 
  unsigned char  c1,c2;
  int c; /* for correct type matching with EOF and getchar();
	    was char c; in the ORIGINAL */

  int KState = 1; /* start at in Hangul state */
  char nonAlphaBuf[80];
  int nsaved = 0; /* <= 79 */
  char *me = argv[0];

        poparg;
        while (argc) {
	  if (!strncmp(*argv, "-h", 2)) {showUsage(me); exit(0);}
	  else if (!strncmp(*argv, "-d", 2)) doCapital = 0;
	  else if (**argv == '-') {showUsage(me); exit(0);}
	  else newStdin(*argv); /* take arg w/o - as input file */
          poparg;
        }

#ifndef READKS		/* Modified to write the beginning of SSHR - dkyoon */
       fprintf (stdout,"\\begin{sshr}\n"); /* show start of SSHR code */
#endif

        while(1) 
           { c=getchar();
	     c1 = (unsigned)c;
#ifdef READKS /* interactive read only, easy */
	     if ( c==EOF ) exit(0);
	     /* put '.' between Hangul and English 
		Alphabet, as in HHHH.EEE or EEE.HHHH */
	     if (ishangul(c1)) {
	       if (C_Mode == ENG) {
		 if (isalpha(p_ch)
		     /* Quick and Dirty, and not quite right, but ...
			not to put '.' after cursor control sequences
			such as ESC[n;mH right before Hangul;
			only check last two input chars. :-( */
#define nonccs(x, y) (!(x>='0'&&x<='9' && y=='H'))
		     && nonccs(pp_ch, p_ch)
		     ) putchar('.');
		 C_Mode = KOR;
	       }
	       doHangul(c1);
	     }
	     else {
	       if (C_Mode == KOR) {
		 if (isalpha(p_ch)) putchar('.');
		 C_Mode = ENG;
	       }
	       putchar(c1);
	     }
	     fflush(stdout);

#else /* for SSHR */
	     /* all the hassle to do {english test} */
	     switch (KState) {
	     case 0: /* in English Alphabet */
	       if ( c == EOF ) {
		 /* putchar('{'); */
		 putchar('}');	/* SeongGuen Hyeon meant be '}' not '{' */
				/* Right ? :-) - dkyoon */
#ifndef READKS
		 /* write the end of SSHR CODE - dkyoon */
		 fprintf(stdout,"\n\\end{sshr}");
#endif
		 exit(0);
	       }
	       else if (isalpha(c1)) {
		 putchar(c1);
		 /*KState=0*/
	       }
	       else if(ishangul(c1)) {
		 putchar('}');
		 doHangul(c1);
		 KState=1;
	       }
	       else { /* non-alpha ascii stuff */
		 saveNonAlpha(c1);
		 KState=2;
	       }
	       break;

	     case 1: /* in Hangul */
	       if ( c == EOF ) {
#ifndef READKS
		 /* write the end of SSHR CODE - dkyoon */
		 fprintf(stdout,"\n\\end{sshr}");
#endif
		 exit(0);
	       }
	       else if (ishangul(c1)) {
		 doHangul(c1);
		 /*KState=1;*/
	       }
	       else if (isalpha(c1)) {
		 putchar('{');
		 putchar(c1);
		 KState=0;
	       }
	       else {
		 putchar(c1);
		 /*KState=1;*/
	       }
	       break;
		 
	     case 2: /* in non-alpha in English */
	       if ( c==EOF ) {
		 putchar('}');
		 flushNonAlpha();
#ifndef READKS
		 /* write the end of SSHR CODE - dkyoon */
		 fprintf(stdout,"\n\\end{sshr}");
#endif
		 exit(0);
	       }
	       else if (isalpha(c1)) {
		 flushNonAlpha();
		 putchar(c1);
		 KState=0;
	       }
	       else if (ishangul(c1)) {
		 putchar('}');
		 flushNonAlpha();
		 doHangul(c1);
		 KState=1;
	       }
	       else {
		 saveNonAlpha(c1);
		 if (nsaved >= 79) {
		   putchar('}');
		   flushNonAlpha();
		   KState = 4;
		 }
		 /*else KState=2;*/
	       }
	       break;

	     /*case 3: is not used */

	     case 4: /* in non-Alpha in non-Alpha */
	       if ( c==EOF ) {
		 exit(0);
	       }
	       else if (isalpha(c1)) {
		 putchar(c1);
		 KState=0;
	       } else if (ishangul(c1)) {
		 doHangul(c1);
		 KState=1;
	       } else {
		 xputchar(c1);
		 /*KState=4*/
	       }
	       break;

	     default:
	       fprintf(stderr, "Ooops, invalid KState=%d.\n", KState);
	       exit(1);
	     } /*SWITCH*/
#endif/*READKS/SSHR*/
	     pp_ch = p_ch;
	     p_ch = c;
           } /* WHILE */
}

#endif

/****   Function which make KSC2S code from Hangule-Character   */
/*      Binary Search algorithm used (Assume ksc2c-ksc2s sorted)*/
int intoCom(key)
int key;
{ int l,u,m,tmp;

        l=0; u= KSC_SIZE -1;
        while(l<=u)
        {       m = (l+u)/2;
                tmp = KSC2CS[m][1];
                if(key  > tmp)  l = m+1;
                else if(key == tmp)  return(KSC2CS[m][0]);
                else if(key  < tmp)  u = m-1;
        }
        l=0; u=KEY_SIZE -1;
        while(l<=u)
        {       m = (l+u)/2;
                tmp = KSC2S_C[m][1];
                if(key  > tmp)  l = m+1;
                else if(key == tmp)  return(KSC2S_C[m][0]);
                else if(key  < tmp)  u = m-1;
        }
        return(key);
}

#include "nbdef.h"
intoNbyte(key)
int key;
{  int cho,jung,jong,i=0;
   char Nbyte[10];

        cho = (key & 0x7c00) >> 10;
        jung= (key & 0x03e0) >> 5;
        jong= (key & 0x001f); 

        Nbyte[i]  = Cho_tbl[cho -8];  if(Nbyte[i]) i++;
        Nbyte[i]  = Jung_tbl[jung];   if(Nbyte[i]) i++;
        if(Jung_ant[jung]) Nbyte[i++]  = Jung_ant[jung];
        Nbyte[i]  = Jong_tbl[jong];   if(Nbyte[i]) i++;
        if(Jong_ant[jong]) Nbyte[i++]  = Jong_ant[jong];
        Nbyte[i] = '\0';
#ifdef ORIGINAL
        printf("%s",Nbyte);
#else /* SSHR or READKS */
/* seong.gueon.eui {SSHR} byeon.hoan ko.deu. */
   {
     char *p, tc ;
     int j, choOO = 0;

#define OO 87 /* OO in nbdef.h */
#define R  73 /* R/L */
     if ( !doCapital && !(p_ch==' '||p_ch=='\t'||p_ch=='\n') ) putchar('.');
     /* handling cho.seong (and jung.seong after OO) and capitalization */
     switch (Nbyte[0]) {
     case OO:
       choOO++; /* skip cho.seong i.eung */
       if (i > 1 ) {
         if (p = nbdef[Nbyte[1]]) { /* put jung.seong */
           putchar(doCapital?(*p+'A'-'a'):*p);
           while (tc = *++p) putchar(tc);
	 } else putchar('@');
       }
       break;
     case R:  putchar(doCapital?'R':'r'); break;
     default: 
       if (p = nbdef[Nbyte[0]]) {
         putchar(doCapital?(*p+'A'-'a'):*p);
         while (tc = *++p) putchar(tc);
       } else putchar('@');
     }

     /* remaining components */
     for (j=1; j<i; j++) {
       if (j==1 && choOO) continue;
       if (p = nbdef[Nbyte[j]]) while(tc = *p++) putchar(tc);
       else putchar('@');
     }
   }
#endif /* ORIGINAL */
}

/***  end of ks2n.c  ***/
