/* %W%	%G% */
%{
/************************************************************************
 ************************************************************************
 *									*
 *	sshr_scan.l : convert sshr code to n-byte code			*
 *									*
 *			Dae-kyun Yoon					*
 *									*
 ************************************************************************
 ************************************************************************/
#include <stdio.h>

#define MAXQSIZE	100
static int NbQueue[MAXQSIZE];
static int qfront=0,qrear=0;

extern FILE *TmpNbFp;
static int lbrace_count = 0;	/* Count '{' to support nested {,} */
static unsigned char in_sshr = 0; /* 1 if in SSHR mode */
static unsigned char small_sshr = 0; /* 1 if in Small SSHR mode */
				     /* "\sshr{...}*/
static unsigned char in_han = 0;  /* 1 if in Hangul mode */
static unsigned char add_ieung = 0; /* 1 if we have cho.seong vowel */
%}

/* miscelleneous defs */

dot		\.
lbrace		\{
rbrace		\}
white_space	[ \t\n]

/* Let's use '@' to represent single Ieung */
at		@

%%

Gg|gg|GG {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (66);
     }
     else
	  write_nb_string ();
     return (1);
}

G|g {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (65);
     }
     else
	  write_nb_string ();
     return (1);
}

gs|GS {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (65);
	  write_nb_char (85);
     }
     else
	  write_nb_string ();
     return (1);
}

n|N {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (68);
     }
     else
	  write_nb_string ();
     return (1);
}

nj|NJ {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (68);
	  write_nb_char (88);
     }
     else
	  write_nb_string ();
     return (1);
}

nh|NH {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (68);
	  write_nb_char (94);
     }
     else
	  write_nb_string ();
     return (1);
}

d|D {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (71);
     }
     else
	  write_nb_string ();
     return (1);
}

dd|Dd|DD {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (72);
     }
     else
	  write_nb_string ();
     return (1);
}

l|L|r|R {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (73);
     }
     else
	  write_nb_string ();
     return (1);
}

rg|RG|lg|LG {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (73);
	  write_nb_char (65);
     }
     else
	  write_nb_string ();
     return (1);
}

rm|RM|lm|LM {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (73);
	  write_nb_char (81);
     }
     else
	  write_nb_string ();
     return (1);
}

rb|RB|lb|LB {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (73);
	  write_nb_char (82);
     }
     else
	  write_nb_string ();
     return (1);
}

rs|RS|ls|LS {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (73);
	  write_nb_char (85);
     }
     else
	  write_nb_string ();
     return (1);
}

rt|RT|lt|LT {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (73);
	  write_nb_char (92);
     }
     else
	  write_nb_string ();
     return (1);
}

rp|RP|lp|LP {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (73);
	  write_nb_char (93);
     }
     else
	  write_nb_string ();
     return (1);
}

rh|RH|lh|LH {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (73);
	  write_nb_char (94);
     }
     else
	  write_nb_string ();
     return (1);
}

m|M {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (81);
     }
     else
	  write_nb_string ();
     return (1);
}

b|B|v|V {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (82);
     }
     else
	  write_nb_string ();
     return (1);
}

bb|BB|Bb {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (83);
     }
     else
	  write_nb_string ();
     return (1);
}

bs|BS {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (82);
	  write_nb_char (85);
     }
     else
	  write_nb_string ();
     return (1);
}

s|S {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (85);
     }
     else
	  write_nb_string ();
     return (1);
}

SS|ss|Ss|X|x {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (86);
     }
     else
	  write_nb_string ();
     return (1);
}

ng|NG {		/* can't begin as cho-seong */
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (87);
     }
     else
	  write_nb_string ();
     return (1);
}

j|J|z|Z {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (88);
     }
     else
	  write_nb_string ();
     return (1);
}

jj|JJ|Jj {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (89);
     }
     else
	  write_nb_string ();
     return (1);
}

ch|CH|Ch {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (90);
     }
     else
	  write_nb_string ();
     return (1);
}

K|k|C|c|Q|q|ck {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (91);
     }
     else
	  write_nb_string ();
     return (1);
}

T|t {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (92);
     }
     else
	  write_nb_string ();
     return (1);
}

p|P|f|F {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (93);
     }
     else
	  write_nb_string ();
     return (1);
}

H|h {
     if (in_sshr && in_han) {
	  add_ieung = 0;
	  write_nb_char (94);
     }
     else
	  write_nb_string ();
     return (1);
}

a {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (98);
     }
     else
	  write_nb_string ();
     return (1);
}

A {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (98);
     }
     else
	  write_nb_string ();
     return (1);
}

ai|ae {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (99);
     }
     else
	  write_nb_string ();
     return (1);
}

Ai|Ae {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (99);
     }
     else
	  write_nb_string ();
     return (1);
}

ya|ia {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (100);
     }
     else
	  write_nb_string ();
     return (1);
}

Ya|Ia {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (100);
     }
     else
	  write_nb_string ();
     return (1);
}

yai|yae|iai|iae {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (101);
     }
     else
	  write_nb_string ();
     return (1);
}

Yai|Yae|Iai|Iae {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (101);
     }
     else
	  write_nb_string ();
     return (1);
}

eo {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (102);
     }
     else
	  write_nb_string ();
     return (1);
}

Eo {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (102);
     }
     else
	  write_nb_string ();
     return (1);
}

e {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (103);
     }
     else
	  write_nb_string ();
     return (1);
}

E {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (103);
     }
     else
	  write_nb_string ();
     return (1);
}

yeo|ieo {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (106);
     }
     else
	  write_nb_string ();
     return (1);
}

Yeo|Ieo {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (106);
     }
     else
	  write_nb_string ();
     return (1);
}

ye|ie {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (107);
     }
     else
	  write_nb_string ();
     return (1);
}

Ye|Ie {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (107);
     }
     else
	  write_nb_string ();
     return (1);
}

o {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (108);
     }
     else
	  write_nb_string ();
     return (1);
}

O {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (108);
     }
     else
	  write_nb_string ();
     return (1);
}

oa|wa {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (108); write_nb_char (98);
     }
     else
	  write_nb_string ();
     return (1);
}

Oa|Wa {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (108); write_nb_char (98);
     }
     else
	  write_nb_string ();
     return (1);
}

oai|oae {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (108);
	  write_nb_char (99);
     }
     else
	  write_nb_string ();
     return (1);
}

Oai|Oae {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (108);
	  write_nb_char (99);
     }
     else
	  write_nb_string ();
     return (1);
}

oi|oe {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (108);
	  write_nb_char (124);
     }
     else
	  write_nb_string ();
     return (1);
}

Oi|Oe {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (108);
	  write_nb_char (124);
     }
     else
	  write_nb_string ();
     return (1);
}

yo|io {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (114);
     }
     else
	  write_nb_string ();
     return (1);
}

Yo|Io {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (114);
     }
     else
	  write_nb_string ();
     return (1);
}

u|w|oo|woo {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (115);
     }
     else
	  write_nb_string ();
     return (1);
}

U|W|Oo|Woo {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (115);
     }
     else
	  write_nb_string ();
     return (1);
}

ueo|weo|wo {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	
	  add_ieung = 0;
	  write_nb_char (115);write_nb_char(102);
     }
     else
	  write_nb_string ();
     return (1);
}

Ueo|Weo|Wo {
     if (in_sshr && in_han) {
	  write_nb_char (87);
	  add_ieung = 0;
	  write_nb_char (115);write_nb_char(102);
     }
     else
	  write_nb_string ();
     return (1);
}

ue|we {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (115);
	  write_nb_char (103);
     }
     else
	  write_nb_string ();
     return (1);
}

Ue|We {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (115);
	  write_nb_char (103);
     }
     else
	  write_nb_string ();
     return (1);
}

ui|wi {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (115);
	  write_nb_char (124);
     }
     else
	  write_nb_string ();
     return (1);
}

Ui|Wi {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (115);
	  write_nb_char (124);
     }
     else
	  write_nb_string ();
     return (1);
}

yu|yoo {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (119);
     }
     else
	  write_nb_string ();
     return (1);
}

Yu|Yoo {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (119);
     }
     else
	  write_nb_string ();
     return (1);
}

eu {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (122);
     }
     else
	  write_nb_string ();
     return (1);
}

Eu {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (122);
     }
     else
	  write_nb_string ();
     return (1);
}

eui {
     if (in_sshr && in_han) {
	  if (add_ieung) 
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (122);
	  write_nb_char (124);
     }
     else
	  write_nb_string ();
     return (1);
}

Eui {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (122);
	  write_nb_char (124);
     }
     else
	  write_nb_string ();
     return (1);
}

i|y|ee {
     if (in_sshr && in_han) {
	  if (add_ieung)
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (124);
     }
     else
	  write_nb_string ();
     return (1);
}

I|Y|Ee {
     if (in_sshr && in_han) {
	       write_nb_char (87);	/* Add cho.seong i.eung */
	  add_ieung = 0;
	  write_nb_char (124);
     }
     else
	  write_nb_string ();
     return (1);
}

\\[Bb][eE][Gg][iI][Nn]{lbrace}[Ss][Ss][Hh][Rr]{rbrace}\n? {
     if (in_sshr) {
	  if (in_han == 0)
	       write_nb_string ();
	  else
	       add_ieung = 1;	/* just ignore redefinition */
     }
     else {
	  in_sshr = in_han = add_ieung = 1; 
	  lbrace_count = 0;
	  write_nb_char (14);
     }
     return (1);
}

\n?\\[eE][Nn][Dd]{lbrace}[Ss][Ss][Hh][Rr]{rbrace} {
     if (in_sshr) {
	  if (in_han == 0)
	       write_nb_string ();
	  else {
	       in_sshr = in_han = add_ieung = 0;
	       lbrace_count = 0;
	       write_nb_char (15);
	  }
     }
     else
	  write_nb_string ();
     return (1);
}

\\[Ss][Ss][Hh][Rr]({white_space}*)?{lbrace} {
     if (in_sshr) {
	  if (in_han == 0) {
	       write_nb_string ();
	  }
	  else {
	       in_han = 0;
	       write_nb_char (15);
	  }
	  lbrace_count++;
     }
     else {
	  in_sshr = small_sshr = in_han = add_ieung = 1; 
	  write_nb_char (14);
     }
     return (1);
}

{at} {
     if (in_sshr && in_han) {
	  write_nb_char (87);	/* i.eung alone */
	  add_ieung = 1;
     }
     else
	  write_nb_string ();
     return (1);
}

{at}{at} {
     if (in_sshr && in_han) {
	  write_nb_char ('@');	/* normal  '@' */
	  add_ieung = 1;
     }
     else
	  write_nb_string ();
}

{lbrace} {
     if (in_sshr) {
	  if (in_han && (lbrace_count == 0)) {
		    in_han = 0;
		    write_nb_char (15);
	  }
	  else
	       write_nb_char ('{');
	  lbrace_count++;
     }
     else
	  write_nb_string ();		
     return (1);
}

{rbrace} {
     if (in_sshr) {
	  lbrace_count--;
	  if (in_han) {
	       if (small_sshr && (lbrace_count == -1)) {
		    in_sshr = small_sshr = in_han = add_ieung = 0;
		    lbrace_count = 0;
		    write_nb_char (15);
	       }
	       else {
		    lbrace_count = 0; /* Just ingnore dangling '}' */
	       }
	  }
	  else {
	       if (lbrace_count == 0) {
		    in_han = 1;
		    add_ieung = 1;
		    write_nb_char (14);
	       }
	       else write_nb_char ('}');
	  }
     }
     else
	  write_nb_string ();
     return (1);
}

{lbrace}{lbrace} {
     if (in_sshr) {
	  if (in_han)
	       write_nb_char ('{');
	  else {
	       write_nb_string ();
	       lbrace_count += 2;
	  }
     }
     else
	  write_nb_string ();
     return (1);
}

{rbrace}{rbrace} {
     if (in_sshr) {
	  if (in_han)
	       write_nb_char ('}');
	  else {
	       int i;
	       for (i=0;i<2;i++) {
		    lbrace_count--;
		    if (small_sshr && (lbrace_count == -1)){
			 in_sshr = small_sshr = in_han = add_ieung = 0;
			 lbrace_count = 0;
			 write_nb_char (15);
		    }
		    else if (lbrace_count == 0) {
			 in_han = 1;
			 add_ieung = 1;
			 write_nb_char (14);
		    }
		    else if (lbrace_count < 0)
			 lbrace_count = 0;	/* ignore dangling '}' */
		    else
			 write_nb_char ('}');
	       }
	  }
     }
     else
	  write_nb_string ();
     return (1);
}

{dot} {
     if (in_sshr && in_han)
	  add_ieung = 1;		/* skip dot */
     else
	  write_nb_string ();
     return (1);
}

{dot}{dot} {
     if (in_sshr && in_han)
	  add_ieung = 1;
     write_nb_string ();
     return (1);
}

{dot}{white_space} {
     if (in_sshr && in_han) {
	  write_nb_char (15);
	  add_ieung = 1;
	  write_nb_string ();
	  write_nb_char (14);
     }
     else
	  write_nb_string ();
     return (1);
}

{white_space} {
     if (in_sshr && in_han) {
	  write_nb_char (15);
	  add_ieung = 1;
	  write_nb_string ();
	  write_nb_char (14);
     }
     else
	  write_nb_string ();
}

. {
     if (in_sshr && in_han) {
	  write_nb_char (15);
	  add_ieung = 1;
	  write_nb_string ();
	  write_nb_char (14);
     }
     else
	  write_nb_string ();
     return (1);
}

%%

yywrap()
{
     return 1;
}


write_nb_char (c)
int c;
{
     qrear = (qrear + 1) % MAXQSIZE;
     NbQueue [qrear] = c;
}

write_nb_string ()
{
     int i;
     for (i=0;i<yyleng;i++) {
	  qrear = (qrear + 1) % MAXQSIZE;
	  NbQueue [qrear] = yytext[i];
     }
}

get_nb_char ()
{
     int c;

     while (qfront == qrear) {
	  if (yylex () == 0)
	       return (EOF);
     }
     qfront = (qfront + 1) % MAXQSIZE;
     c = NbQueue [qfront];
     return (c);
}
